Imports System.Runtime.InteropServices
Imports System.IO
Public Class Form1
    Public rowz = 20
    Public horv
    'HANDLES MOUSE EVENTS WHEN MOUSE MOVES OVER AN ICON ON BAR
    Private Sub Lab_MouseEnter(ByVal sender As System.Object, ByVal e As System.EventArgs)
        CType(sender, PictureBox).Size = New Size(40, 40)
        If horv = "top" Then
            CType(sender, PictureBox).Location = New Point(sender.Location.X - 5, sender.Location.Y)
        ElseIf horv = "bottom" Then
            CType(sender, PictureBox).Location = New Point(sender.Location.X - 5, sender.Location.Y)
        ElseIf horv = "right" Then
            CType(sender, PictureBox).Location = New Point(sender.Location.X - 5, sender.Location.Y)
        Else
            CType(sender, PictureBox).Location = New Point(sender.Location.X + 5, sender.Location.Y)
        End If
    End Sub
    Private Sub Lab_MouseLeave(ByVal sender As System.Object, ByVal e As System.EventArgs)
        CType(sender, PictureBox).Size = New Size(30, 30)
        If horv = "top" Then
            CType(sender, PictureBox).Location = New Point(sender.Location.X + 5, sender.Location.Y)
        ElseIf horv = "bottom" Then
            CType(sender, PictureBox).Location = New Point(sender.Location.X + 5, sender.Location.Y)
        ElseIf horv = "right" Then
            CType(sender, PictureBox).Location = New Point(sender.Location.X + 5, sender.Location.Y)
        Else
            CType(sender, PictureBox).Location = New Point(sender.Location.X - 5, sender.Location.Y)
        End If
    End Sub
    'THIS IS WHAT HAPPENS WHEN YOU CLICK AN ICON ON THE BAR - OPENS or DELETES
    Private Sub Fclick(ByVal sender As System.Object, ByVal e As System.EventArgs)
        If RemoveToolStripMenuItem.Checked = True Then
            Dim findlink As String = CType(sender, PictureBox).Tag.ToString
            Dim replace As String = ""
            Dim indx As Integer = RichTextBox1.Find(findlink)
            If indx <> -1 Then
                RichTextBox1.Select(indx, findlink.Length)
                If RichTextBox1.SelectedText <> "" Then
                    RichTextBox1.SelectedText = replace
                End If
            End If
            CType(sender, PictureBox).Dispose()
            saveme()

        Else
            Dim w = CType(sender, PictureBox).Tag.ToString
            System.Diagnostics.Process.Start(w)
        End If
    End Sub
    'READS SAVED ICONS AND LOADS THEM AT STARTUP INTO THE BAR
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        horv = Convert.ToString(My.Settings.loc)
        Dim back = Convert.ToString(My.Settings.backg)
        Dim ftime = Convert.ToString(My.Settings.first)
        If ftime = "1" Then
            Dim theSecondForm As New Form2()
            theSecondForm.ShowDialog()
            My.Settings.first = "0"
            My.Settings.Save()
        End If
        If My.Computer.FileSystem.FileExists(Application.StartupPath + "\Settings.bar") Then
            Dim lines = IO.File.ReadAllLines(Application.StartupPath + "\Settings.bar")
            For Each line As String In lines
                If line <> "" Then
                    RichTextBox1.AppendText(line + vbNewLine)
                    Dim w As New PictureBox
                    Try
                        Using ico As Icon = Drawing.Icon.ExtractAssociatedIcon(line)
                            Dim s = ico.ToBitmap
                            w.Image = s
                        End Using
                    Catch
                        w.BackColor = Color.Aqua
                    End Try
                    If horv = "top" Then
                        w.Location = New Point(rowz, 5)
                        Me.Width += 40
                        Me.CenterToScreen()
                        Me.Top = Screen.PrimaryScreen.Bounds.X
                    ElseIf horv = "left" Then
                        w.Location = New Point(5, rowz)
                        Me.Height += 40
                        ' Me.Width -= 10
                        Me.CenterToScreen()
                        Me.Left = Screen.PrimaryScreen.Bounds.Y
                    ElseIf horv = "right" Then
                        w.Location = New Point(5, rowz)
                        Me.Height += 40
                        ' Me.Width -= 10
                        Me.CenterToScreen()
                        Me.Left = Screen.PrimaryScreen.Bounds.Width - Me.Width
                        '  Me.Top = Screen.PrimaryScreen.Bounds.Height - Me.Height
                    ElseIf horv = "bottom" Then
                        w.Location = New Point(rowz, 5)
                        Me.Width += 40
                        Me.CenterToScreen()
                        'Me.Left = Screen.PrimaryScreen.Bounds.Width - Me.Width
                        'Me.Top = Screen.PrimaryScreen.Bounds.Height + -Me.Height
                        Me.Top = Screen.PrimaryScreen.WorkingArea.Height - Me.Height
                    End If
                    w.Size = New Size(30, 30)
                    w.Tag = line
                    w.BackColor = Color.Transparent
                    w.SizeMode = PictureBoxSizeMode.StretchImage
                    AddHandler w.Click, AddressOf Fclick
                    AddHandler w.MouseEnter, AddressOf Lab_MouseEnter
                    AddHandler w.MouseLeave, AddressOf Lab_MouseLeave
                    Me.Controls.Add(w)
                    rowz += 40
                End If
            Next
        End If
        If horv = "top" Then
            Me.Width -= 80
            Me.CenterToScreen()
            Me.Top = Screen.PrimaryScreen.Bounds.X
        ElseIf horv = "left" Then
            Me.Width -= 70
            Me.CenterToScreen()
            Me.Left = Screen.PrimaryScreen.Bounds.Y
        ElseIf horv = "right" Then
            Me.Width -= 70
            ' Me.Width -= 10
            Me.CenterToScreen()
            Me.Left = Screen.PrimaryScreen.Bounds.Width - Me.Width
        ElseIf horv = "bottom" Then
            Me.CenterToScreen()
            Me.Width -= 80
            ' Me.Left = Screen.PrimaryScreen.Bounds.Width - Me.Width
            ' Me.Top = Screen.PrimaryScreen.Bounds.Height + -Me.Height
            Me.Top = Screen.PrimaryScreen.WorkingArea.Height - Me.Height
        End If
        If back = "" Then
        Else
            Me.BackgroundImage = System.Drawing.Image.FromFile(back)
        End If
    End Sub
    'DETECTS PROGRAM DRAGGED ONTO BAR AND ADDs IT and SHOWS ITS ICON
    Private Sub Form1_DragDrop(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles MyBase.DragDrop
        If e.Data.GetDataPresent(DataFormats.FileDrop) Then
            Dim draggedFiles As String() = CType(e.Data.GetData(DataFormats.FileDrop), String())
            For Each filename As String In draggedFiles
                RichTextBox1.AppendText(filename + vbNewLine)
                Dim w As New PictureBox
                Using ico As Icon = Drawing.Icon.ExtractAssociatedIcon(filename)
                    Dim s = ico.ToBitmap
                    w.Image = s
                End Using
                If horv = "top" Then
                    w.Location = New Point(rowz, 5)
                    Me.Width += 40
                    Me.CenterToScreen()
                    Me.Top = Screen.PrimaryScreen.Bounds.X
                ElseIf horv = "left" Then
                    w.Location = New Point(5, rowz)
                    Me.Height += 40
                    ' Me.Width -= 10
                    Me.CenterToScreen()
                    Me.Left = Screen.PrimaryScreen.Bounds.Y
                ElseIf horv = "right" Then
                    w.Location = New Point(5, rowz)
                    Me.Height += 40
                    ' Me.Width -= 10
                    Me.CenterToScreen()
                    Me.Left = Screen.PrimaryScreen.WorkingArea.Width + -Me.Width
                ElseIf horv = "bottom" Then
                    w.Location = New Point(rowz, 5)
                    Me.Width += 40
                    Me.CenterToScreen()
                    'Me.Left = Screen.PrimaryScreen.Bounds.Width - Me.Width
                    ' Me.Top = Screen.PrimaryScreen.Bounds.Height + -Me.Height
                    Me.Top = Screen.PrimaryScreen.WorkingArea.Height - Me.Height
                End If
                w.Size = New Size(30, 30)
                w.Tag = filename
                w.BackColor = Color.Transparent
                AddHandler w.Click, AddressOf Fclick
                AddHandler w.MouseEnter, AddressOf Lab_MouseEnter
                AddHandler w.MouseLeave, AddressOf Lab_MouseLeave
                Me.Controls.Add(w)
                'Me.Width += 40
                rowz += 40
            Next
            saveme()
        End If
    End Sub
    'CHECKS TO MAKE SURE ITEM DRAGGED IS A FILE
    Private Sub Form1_DragEnter(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles MyBase.DragEnter
        If e.Data.GetDataPresent(DataFormats.FileDrop) Then
            e.Effect = DragDropEffects.Copy
        End If
    End Sub
    'SAVES THE SHORTCUTS
    Public Sub saveme()
        If My.Computer.FileSystem.FileExists(Application.StartupPath + "\Settings.bar") Then
            My.Computer.FileSystem.DeleteFile(Application.StartupPath + "\Settings.bar", FileIO.UIOption.OnlyErrorDialogs, FileIO.RecycleOption.DeletePermanently)
        End If
        My.Computer.FileSystem.WriteAllText(Application.StartupPath + "\Settings.bar", RichTextBox1.Text, True)
    End Sub
    Private Sub Form1_MouseDoubleClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseDoubleClick
        Me.Close()
    End Sub
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        ' froma = Convert.ToString(My.Settings.From)
        ' My.Settings.pass = TextBox7.Text
        ' My.Settings.Save()
    End Sub

    Private Sub TopToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TopToolStripMenuItem.Click
        My.Settings.loc = "top"
        My.Settings.Save()
        Application.Restart()
    End Sub

    Private Sub LeftToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LeftToolStripMenuItem.Click
        My.Settings.loc = "left"
        My.Settings.Save()
        Application.Restart()
    End Sub

    Private Sub RightToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RightToolStripMenuItem.Click
        My.Settings.loc = "right"
        My.Settings.Save()
        Application.Restart()
    End Sub

    Private Sub BottomToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BottomToolStripMenuItem.Click
        My.Settings.loc = "bottom"
        My.Settings.Save()
        Application.Restart()
    End Sub

    Private Sub RemoveToolStripMenuItem_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RemoveToolStripMenuItem.CheckedChanged
        If RemoveToolStripMenuItem.Checked = False Then
            Application.Restart()
        End If
    End Sub

    Private Sub ThemeToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ThemeToolStripMenuItem.Click
        If OpenFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
            Me.BackgroundImage = System.Drawing.Image.FromFile(OpenFileDialog1.FileName)
            My.Settings.backg = OpenFileDialog1.FileName
            My.Settings.Save()
        End If
    End Sub

    Private Sub AlwaysOnTopToolStripMenuItem_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AlwaysOnTopToolStripMenuItem.CheckedChanged
        If AlwaysOnTopToolStripMenuItem.Checked = False Then
            Me.TopMost = False
        Else
            Me.TopMost = True
        End If
    End Sub
End Class
